import {
  getOutlookUrl,
  getZoomUrl,
  getThirdUserPlatForm,
  unbindingApp
} from "../../api/request";
import "dingtalk-jsapi/entry/mobile";
import openLink from "dingtalk-jsapi/api/biz/util/openLink";
import create from "dd-store";
let interval = "";
let requestNum = 0;
create.Page({
  data: {
    $data: null,
    url: "",
    platform: "",
    name: "",
    isBind: false,
    isLoading: false,
    showSelectPopup: false,
    selectPopupList: [{ text: "取消关联" }]
  },
  onLoad(e) {
    this.setData({
      platform: e.platform,
      name: e.userName,
      isBind: e.userName ? true : false
    });
  },
  onShow() {},
  sendRequest() {
    let that = this;
    interval = setInterval(() => {
      if (requestNum >= 300) {
        requestNum = 0;
        that.setData({
          isBind: true,
          isLoading: false
        });
        clearInterval(interval);
      }
      requestNum++;
      getThirdUserPlatForm().then(res => {
        let relatedAppPlatformList = [];
        res.data.data.forEach(item => {
          if (item.platform === this.data.platform) {
            this.setData({
              name: item.userName,
              isBind: true,
              isLoading: false
            });
            this.$store.data.relatedAppNeedUpdate = {
              name: item.userName,
              platform: this.data.platform
            };
            this.update();
          }
        });
      });
    }, 1000);
  },
  bindApp() {
    if (this.data.isLoading) {
      return false;
    }
    this.setData({
      isLoading: true
    });
    this.sendRequest();
    if (this.data.platform === "outlook") {
      let data = `${getApp().globalData.userid},${dd.corpId}`;
      getOutlookUrl(data).then(res => {
        openLink({
          url: res.data.data
        });
      });
    } else if (this.data.platform === "zoom") {
      let data = {
        userId: getApp().globalData.userid,
        orgId: dd.corpId
      };
      getZoomUrl(data).then(res => {
        openLink({
          url: res.data.data
        });
      });
    }
  },
  unbind() {
    unbindingApp(this.data.platform).then(res => {
      if (res.data.data) {
        this.setData({
          name: "",
          isBind: false,
          showSelectPopup: false
        });
        this.$store.data.relatedAppNeedUpdate = "1";
        this.update();
      }
    });
  },
  onSelectPopup(e) {
    if (e.target.dataset.item.text === "取消关联") {
      this.unbind();
    }
  },
  onSelectPopupCancel() {
    this.setData({
      showSelectPopup: false
    });
  },
  showPopup() {
    this.setData({
      showSelectPopup: true
    });
  },
  onUnload() {
    clearInterval(interval);
  }
});
